#!/bin/ksh

if [ $# -ne 2 ]
then
   echo ""
   echo "${0} YYYY MM"
   echo ""
   exit
fi
 

DIRHOME=/scripts/clima/users/renato/figsIniciaisBAM1.2
SCRIPTS=${DIRHOME}/scripts
DATAOUT=${DIRHOME}/dataout
DATAIN=${DIRHOME}/datain


yyyyci=${1} # ${yyyyci}
mmci=${2}   # ${mmci}


yyyytri1=$(date -u +"%Y" -d "${yyyyci}${mmci}15 2 months")  # ${yyyytri1}
mmtri1=$(date -u +"%m" -d "${yyyyci}${mmci}15 2 months")    # ${mmtri1}
mmmtri1=$(date -u +"%b" -d "${yyyyci}${mmci}15 2 months")   # ${mmmtri1}
mmmtri2=$(date -u +"%b" -d "${yyyyci}${mmci}15 3 months")   # ${mmmtri2}
yyyytri3=$(date -u +"%Y" -d "${yyyyci}${mmci}15 4 months")  # ${yyyytri3}
mmtri3=$(date -u +"%m" -d "${yyyyci}${mmci}15 4 months")    # ${mmtri3}
mmmtri3=$(date -u +"%b" -d "${yyyyci}${mmci}15 4 months")   # ${mmmtri3}
temp=$(date -u +"%Y%m01" -d "${yyyyci}${mmci}15 5 months")  # ${temp}
lddtri3=$(date -u +"%d" -d "${temp} 1 day ago")             # ${lddtri3}
yyyytri1lagyyyytri3=$(echo "${yyyytri3}-${yyyytri1}" | bc)  # ${yyyytri1lagyyyytri3}
TRI=$(echo "${mmmtri1}" | cut -c1)$(echo "${mmmtri2}" | cut -c1)$(echo "${mmmtri3}" | cut -c1)  # ${TRI}


mkdir -p ${DATAOUT}/${yyyyci}${mmci}

rm -f ${SCRIPTS}/correlacao.gs
cat <<EOGS>${SCRIPTS}/correlacao.gs
'reinit'

say 'open ../dataout/${yyyyci}${mmci}/observacao.ctl'
'open ../dataout/${yyyyci}${mmci}/observacao.ctl'

say 'open ../dataout/${yyyyci}${mmci}/hindcast.ctl'
'open ../dataout/${yyyyci}${mmci}/hindcast.ctl'

xi=1
xf=384

yi=1
yf=191

'define corrp=aprec.1(t=1)*0.0'
'define corrt=atmp.1(t=1)*0.0'
'define corrpr=aspmt.1(t=1)*0.0'
'set t 1'

xx=xi
while (xx <= xf)
   'set x 'xx''
   yy=yi
   say xx'/'xf
   while (yy <= yf)
      'set y 'yy''

      'define cop=tcorr(aprec.1, aprec.2, t=1, t=30)'
      'd cop'

      valcop=subwrd(result, 4)
      'set defval corrp 'xx' 'yy' 'valcop
      
      'define cot=tcorr(atmp.1, atmp.2, t=1, t=30)'
      'd cot'
      
      valcot=subwrd(result, 4)
      'set defval corrt 'xx' 'yy' 'valcot

      'define copr=tcorr(aspmt.1, aspmt.2, t=1, t=30)'
      'd copr'
      
      valcop=subwrd(result, 4)
      'set defval corrpr 'xx' 'yy' 'valcop
      
      yy=yy+1
   endwhile
   
   xx=xx+1
endwhile

'set x 'xi' 'xf''
'set y 'yi' 'yf''
    
'set gxout fwrite'
say 'set fwrite ../dataout/${yyyyci}${mmci}/correlacao.bin'
'set fwrite ../dataout/${yyyyci}${mmci}/correlacao.bin'

'd corrp'
'd corrt'
'd corrpr'

'disable fwrite'

'quit'
EOGS

rm -f ${DATAOUT}/${yyyyci}${mmci}/correlacao.bin
grads -blc "run correlacao.gs"

rm -f ${DATAOUT}/${yyyyci}${mmci}/correlacao.ctl
cat <<EOCTL>${DATAOUT}/${yyyyci}${mmci}/correlacao.ctl
DSET ^correlacao.bin
UNDEF -9.99e+08
TITLE AMJ
xdef   384 linear    0.000   0.9375000000
ydef   191 linear  -89.531   0.9375000000
ZDEF     6  LEVELS  1000  925  850  500  250  200
TDEF 1 LINEAR ${mmmtri1}1981 1yr
VARS   3
corr    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
corrt    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
corrp    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
ENDVARS
EOCTL

