#!/bin/ksh

if [ $# -ne 2 ]
then
   echo ""
   echo "${0} YYYY MM"
   echo ""
   exit
fi
 

DIRHOME=/scripts/clima/users/renato/figsIniciaisBAM1.2
SCRIPTS=${DIRHOME}/scripts
DATAOUT=${DIRHOME}/dataout
DATAIN=${DIRHOME}/datain


yyyyci=${1} # ${yyyyci}
mmci=${2}   # ${mmci}


yyyytri1=$(date -u +"%Y" -d "${yyyyci}${mmci}15 2 months")  # ${yyyytri1}
mmtri1=$(date -u +"%m" -d "${yyyyci}${mmci}15 2 months")    # ${mmtri1}
mmmtri1=$(date -u +"%b" -d "${yyyyci}${mmci}15 2 months")   # ${mmmtri1}
mmmtri2=$(date -u +"%b" -d "${yyyyci}${mmci}15 3 months")   # ${mmmtri2}
yyyytri3=$(date -u +"%Y" -d "${yyyyci}${mmci}15 4 months")  # ${yyyytri3}
mmtri3=$(date -u +"%m" -d "${yyyyci}${mmci}15 4 months")    # ${mmtri3}
mmmtri3=$(date -u +"%b" -d "${yyyyci}${mmci}15 4 months")   # ${mmmtri3}
temp=$(date -u +"%Y%m01" -d "${yyyyci}${mmci}15 5 months")  # ${temp}
lddtri3=$(date -u +"%d" -d "${temp} 1 day ago")             # ${lddtri3}
yyyytri1lagyyyytri3=$(echo "${yyyytri3}-${yyyytri1}" | bc)  # ${yyyytri1lagyyyytri3}
TRI=$(echo "${mmmtri1}" | cut -c1)$(echo "${mmmtri2}" | cut -c1)$(echo "${mmmtri3}" | cut -c1)  # ${TRI}

mkdir -p ${DATAOUT}/${yyyyci}${mmci}



rm -f ${SCRIPTS}/hindcast_temp.gs
cat <<EOGS>${SCRIPTS}/hindcast_temp.gs
'reinit'


* dummy:
say 'dummy: open /oper/share/clima/modelos/BAM1.2/${TRI}/1981${mmci}10/gposmm1981${mmci}10.ctl'
'open /oper/share/clima/modelos/BAM1.2/${TRI}/1981${mmci}10/gposmm1981${mmci}10.ctl'


'set x 1 384'
'set y 1 192'


'set gxout fwrite'
say 'set fwrite ../dataout/${yyyyci}${mmci}/hindcast_temp.bin'
'set fwrite ../dataout/${yyyyci}${mmci}/hindcast_temp.bin'



yyyyi=1981
yyyyf=2010
yyyy=yyyyi
   
while (yyyy <= yyyyf)

   'define ens=0.0'
   'define enst=0.0'
   'define ensp=0.0'
  
   
   ddi=10
   i=2
   while (ddi <= 19)
   
      say 'open /oper/share/clima/modelos/BAM1.2/${TRI}/'yyyy'${mmci}'ddi'/gposmm'yyyy'${mmci}'ddi'.ctl'
      'open /oper/share/clima/modelos/BAM1.2/${TRI}/'yyyy'${mmci}'ddi'/gposmm'yyyy'${mmci}'ddi'.ctl'
      'set dfile 'i''
      
      say 'define ens=ens+sum(prec.'i', time=01${mmmtri1}'yyyy', time=${lddtri3}${mmmtri3}'yyyy+${yyyytri1lagyyyytri3}')' 
      'define ens=ens+sum(prec.'i', time=01${mmmtri1}'yyyy', time=${lddtri3}${mmmtri3}'yyyy+${yyyytri1lagyyyytri3}')' 


      say 'define enst=enst+ave(tp2m.'i', time=01${mmmtri1}'yyyy', time=${lddtri3}${mmmtri3}'yyyy+${yyyytri1lagyyyytri3}')' 
      'define enst=enst+ave(tp2m.'i', time=01${mmmtri1}'yyyy', time=${lddtri3}${mmmtri3}'yyyy+${yyyytri1lagyyyytri3}')' 
      
      say 'define ensp=ensp+ave(SPMT.'i', time=01${mmmtri1}'yyyy', time=${lddtri3}${mmmtri3}'yyyy+${yyyytri1lagyyyytri3}')' 
      'define ensp=ensp+ave(SPMT.'i', time=01${mmmtri1}'yyyy', time=${lddtri3}${mmmtri3}'yyyy+${yyyytri1lagyyyytri3}')' 
   
      i=i+1
      say ''
      ddi=ddi+1
   endwhile   
   
   say 'define ens=ens/10'
   'define ens=ens/10'

   say 'define enst=enst/10'
   'define enst=enst/10'

   say 'define ensp=ensp/10'
   'define ensp=ensp/10'
   
   say ''
   
   
   'd ens'
   'd enst'
   'd ensp'

   

   'close 11'
   'close 10'
   'close 9'
   'close 8'
   'close 7'
   'close 6'
   'close 5'
   'close 4'
   'close 3'
   'close 2'


   yyyy=yyyy+1
endwhile
say ''

'disable fwrite'




'quit'
EOGS


rm -f ${DATAOUT}/${yyyyci}${mmci}/hindcast_temp.bin    
grads -blc "run hindcast_temp.gs"

rm -f ${DATAOUT}/${yyyyci}${mmci}/hindcast_temp.ctl
cat <<EOCTL>${DATAOUT}/${yyyyci}${mmci}/hindcast_temp.ctl
DSET ^hindcast_temp.bin
UNDEF -9.99e+08
TITLE AMJ 
xdef   384 linear    0.000   0.9375000000
ydef   192 linear  -89.531   0.9375000000
ZDEF     6  LEVELS  1000  925  850  500  250  200
TDEF 30 LINEAR ${mmmtri1}1981 1yr
VARS   3
PREC    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
TMP    0 99 TEMPERATURE AT 2-M FROM SURFACE         (K               )
SPMT    0 99 TIME MEAN SEA LEVEL PRESSURE            (Mb-1000         )
ENDVARS
EOCTL


rm -f ${SCRIPTS}/hindcast.gs
cat <<EOGS>${SCRIPTS}/hindcast.gs
'reinit'

say 'open ../dataout/${yyyyci}${mmci}/hindcast_temp.ctl'
'open ../dataout/${yyyyci}${mmci}/hindcast_temp.ctl'

'set x 1 384'
'set y 1 192'

'define med=ave(prec.1, t=1, t=30)'
'define medt=ave(tmp.1, t=1, t=30)'
'define medp=ave(spmt.1, t=1, t=30)'

'set gxout fwrite'
say 'set fwrite ../dataout/${yyyyci}${mmci}/hindcast.bin'
'set fwrite ../dataout/${yyyyci}${mmci}/hindcast.bin'

tti=1
ttf=30
tt=tti
while(tt <= ttf)
   'set t 'tt
   
   'd prec.1'
   'd prec.1-med'
   'd tmp.1'
   'd tmp.1-medt'
   'd spmt.1'
   'd spmt.1-medp'
   
   tt=tt+1
endwhile

'disable fwrite'

'quit'
EOGS

rm -f ${DATAOUT}/${yyyyci}${mmci}/hindcast.bin
grads -blc "run hindcast.gs"

rm -f ${DATAOUT}/${yyyyci}${mmci}/hindcast.ctl
cat <<EOCTL>${DATAOUT}/${yyyyci}${mmci}/hindcast.ctl
DSET ^hindcast.bin
UNDEF -9.99e+08
TITLE AMJ
xdef   384 linear    0.000   0.9375000000
ydef   192 linear  -89.531   0.9375000000
ZDEF     6  LEVELS  1000  925  850  500  250  200
TDEF 30 LINEAR ${mmmtri1}1981 1yr
VARS   6
PREC    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
APREC    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
TMP    0 99 TEMPERATURE AT 2-M FROM SURFACE         (K               )
ATMP    0 99 TEMPERATURE AT 2-M FROM SURFACE         (K               )
SPMT    0 99 TIME MEAN SEA LEVEL PRESSURE            (Mb-1000         )
ASPMT    0 99 TIME MEAN SEA LEVEL PRESSURE            (Mb-1000         )
ENDVARS
EOCTL
