#!/bin/ksh

if [ $# -ne 2 ]
then
   echo ""
   echo "${0} YYYY MM"
   echo ""
   exit
fi
 

DIRHOME=/scripts/clima/users/renato/figsIniciaisBAM1.2
SCRIPTS=${DIRHOME}/scripts
DATAOUT=${DIRHOME}/dataout
DATAIN=${DIRHOME}/datain


yyyyci=${1} # ${yyyyci}
mmci=${2}   # ${mmci}


yyyytri1=$(date -u +"%Y" -d "${yyyyci}${mmci}15 2 months")  # ${yyyytri1}
mmtri1=$(date -u +"%m" -d "${yyyyci}${mmci}15 2 months")    # ${mmtri1}
mmmtri1=$(date -u +"%b" -d "${yyyyci}${mmci}15 2 months")   # ${mmmtri1}
mmmtri2=$(date -u +"%b" -d "${yyyyci}${mmci}15 3 months")   # ${mmmtri2}
yyyytri3=$(date -u +"%Y" -d "${yyyyci}${mmci}15 4 months")  # ${yyyytri3}
mmtri3=$(date -u +"%m" -d "${yyyyci}${mmci}15 4 months")    # ${mmtri3}
mmmtri3=$(date -u +"%b" -d "${yyyyci}${mmci}15 4 months")   # ${mmmtri3}
temp=$(date -u +"%Y%m01" -d "${yyyyci}${mmci}15 5 months")  # ${temp}
lddtri3=$(date -u +"%d" -d "${temp} 1 day ago")             # ${lddtri3}
yyyytri1lagyyyytri3=$(echo "${yyyytri3}-${yyyytri1}" | bc)  # ${yyyytri1lagyyyytri3}
TRI=$(echo "${mmmtri1}" | cut -c1)$(echo "${mmmtri2}" | cut -c1)$(echo "${mmmtri3}" | cut -c1)  # ${TRI}

mkdir -p ${DATAOUT}/${yyyyci}${mmci}

rm -f ${SCRIPTS}/observacao.gs
cat <<EOGS>${SCRIPTS}/observacao.gs
'reinit'


* GPCP2.2: PREC
say 'sdfopen /scripts/clima/ecflow/operacao2/multi_modelos/observacao/../datain/observacao_row/gpcp_22.nc'
'sdfopen /scripts/clima/ecflow/operacao2/multi_modelos/observacao/../datain/observacao_row/gpcp_22.nc'

* ERA5: T2m
say 'sdfopen /scripts/clima/ecflow/operacao2/multi_modelos/observacao/../datain/observacao_row/ERA5T2m1980-2011.nc'
'sdfopen /scripts/clima/ecflow/operacao2/multi_modelos/observacao/../datain/observacao_row/ERA5T2m1980-2011.nc'

* ERA5: pressao
*say 'sdfopen /dados/clima/users/renato/copernicus/dataout//pressao/ERA5pressao1980-2011.nc'
*'sdfopen /dados/clima/users/renato/copernicus/dataout//pressao/ERA5pressao1980-2011.nc'

* ERA5: pressao
say 'sdfopen /dados/clima/users/renato/copernicus/dataout//pressao/ERA5pressaoNivelMedioDoMar1980-2011.nc'
'sdfopen /dados/clima/users/renato/copernicus/dataout//pressao/ERA5pressaoNivelMedioDoMar1980-2011.nc'



* capturando o nome da variavel do arquivo aberto:
'q file 1'
linha=sublin(result, 7)
var=subwrd(linha, 1)
say ''
say var
'q file 2'
linha=sublin(result, 7)
var2=subwrd(linha, 1)
say ''
say var2
'q file 3'
linha=sublin(result, 7)
var3=subwrd(linha, 1)
say ''
say var3
*-------------------------------------------------
'q file 1'

* dummy:
say 'dummy: open /oper/share/clima/modelos/BAM1.2/${TRI}/1981${mmci}10/gposmm1981${mmci}10.ctl'
'open /oper/share/clima/modelos/BAM1.2/${TRI}/1981${mmci}10/gposmm1981${mmci}10.ctl'


'set lon 0 360'
'set lat -89.531 89.531'

*'set dfile 3'
*'q dims'
*say result
*'

'define soma='var'(t=1)*0.0'
'define soma2='var2'.2(t=1)*0.0'
'define soma3='var3'.3(t=1)*0.0'

yi=1981
yf=2010

iano=0
while(yi<=yf)
   say 'define medtri=sum('var',time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'
   'define medtri=sum('var',time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'
   say 'define medtri2=ave('var2'.2,time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'
   'define medtri2=ave('var2'.2,time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'
   say 'define medtri3=ave('var3'.3,time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'
   'define medtri3=ave('var3'.3,time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'
   
   'define soma=soma+medtri'
   'define soma2=soma2+medtri2'
   'define soma3=soma3+medtri3'

   yi=yi+1
   iano=iano+1
endwhile

'define clim=soma/'iano''
'define clim2=soma2/'iano''
'define clim3=soma3/'iano''

'set gxout fwrite'
say 'set fwrite ../dataout/${yyyyci}${mmci}/observacao.bin'
'set fwrite ../dataout/${yyyyci}${mmci}/observacao.bin'




yi=1981
yf=2010


while(yi<=yf)
   'define medtri=sum('var',time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'
   'define medtri2=ave('var2'.2,time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'
   'define medtri3=ave('var3'.3,time=01${mmmtri1}'yi', time=${lddtri3}${mmmtri3}'yi+${yyyytri1lagyyyytri3}')'

   'define anom=medtri-clim'
   'define anom2=medtri2-clim2'
   'define anom3=medtri3-clim3'

*   'd lterp(anom, prec.3(t=1))*30'
*   'd lterp(anom2, prec.3(t=1))'
  'd re(anom, 0.93750, 0.93750)'
  'd re(anom2, 0.93750, 0.93750)'
  'd re(anom3, 0.93750, 0.93750)'
 
   
*   'd lterp(medtri, prec.3(t=1))*30'
*   'd lterp(medtri2, prec.3(t=1))'
  'd re(medtri, 0.93750, 0.93750)'
  'd re(medtri2, 0.93750, 0.93750)'
  'd re(medtri3, 0.93750, 0.93750)'

   yi=yi+1
endwhile


'disable fwrite'


'quit'


EOGS



rm -f ${DATAOUT}/${yyyyci}${mmci}/observacao.bin
grads -blc "run ${SCRIPTS}/observacao.gs"

rm -f ${DATAOUT}/${yyyyci}${mmci}/observacao.ctl
cat <<EOCTL>${DATAOUT}/${yyyyci}${mmci}/observacao.ctl
DSET ^observacao.bin
UNDEF -9.99e+08
TITLE AMJ
xdef   384 linear    0.000   0.9375000000
ydef   191 linear  -89.531   0.9375000000
ZDEF     6  LEVELS  1000  925  850  500  250  200
TDEF     30 LINEAR ${mmmtri1}1981 1yr
VARS    6
APREC    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
ATMP    0 99 TEMPERATURE AT 2-M FROM SURFACE         (K               )
ASPMT    0 99 TEMPERATURE AT 2-M FROM SURFACE         (K               )
PREC    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
TMP    0 99 TEMPERATURE AT 2-M FROM SURFACE         (K               )
SPMT    0 99 TEMPERATURE AT 2-M FROM SURFACE         (K               )
ENDVARS
EOCTL

