#!/bin/ksh

if [ $# -ne 2 ]
then
   echo ""
   echo "${0} YYYY MM"
   echo ""
   exit
fi
 

DIRHOME=/scripts/clima/users/renato/figsIniciaisBAM1.2
SCRIPTS=${DIRHOME}/scripts
DATAOUT=${DIRHOME}/dataout
DATAIN=${DIRHOME}/datain


yyyyci=${1} # ${yyyyci}
mmci=${2}   # ${mmci}


yyyytri1=$(date -u +"%Y" -d "${yyyyci}${mmci}15 2 months")  # ${yyyytri1}
mmtri1=$(date -u +"%m" -d "${yyyyci}${mmci}15 2 months")    # ${mmtri1}
mmmtri1=$(date -u +"%b" -d "${yyyyci}${mmci}15 2 months")   # ${mmmtri1}
mmmtri2=$(date -u +"%b" -d "${yyyyci}${mmci}15 3 months")   # ${mmmtri2}
yyyytri3=$(date -u +"%Y" -d "${yyyyci}${mmci}15 4 months")  # ${yyyytri3}
mmtri3=$(date -u +"%m" -d "${yyyyci}${mmci}15 4 months")    # ${mmtri3}
mmmtri3=$(date -u +"%b" -d "${yyyyci}${mmci}15 4 months")   # ${mmmtri3}
temp=$(date -u +"%Y%m01" -d "${yyyyci}${mmci}15 5 months")  # ${temp}
lddtri3=$(date -u +"%d" -d "${temp} 1 day ago")             # ${lddtri3}
yyyytri1lagyyyytri3=$(echo "${yyyytri3}-${yyyytri1}" | bc)  # ${yyyytri1lagyyyytri3}
TRI=$(echo "${mmmtri1}" | cut -c1)$(echo "${mmmtri2}" | cut -c1)$(echo "${mmmtri3}" | cut -c1)  # ${TRI}




rm -f ${DATAOUT}/correlacao.bin
grads -blc "run correlacao.gs"

rm -f ${DATAOUT}/correlacao.ctl
cat <<EOCTL>${DATAOUT}/correlacao.ctl
DSET ^correlacao.bin
UNDEF -9.99e+08
TITLE AMJ
xdef   384 linear    0.000   0.9375000000
ydef   191 linear  -89.531   0.9375000000
ZDEF     6  LEVELS  1000  925  850  500  250  200
TDEF 1 LINEAR ${mmmtri1}1981 1yr
VARS   3
corr    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
corrt    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
corrp    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
ENDVARS
EOCTL

