#!/bin/ksh

if [ $# -ne 2 ]
then
   echo ""
   echo "${0} YYYY MM"
   echo ""
   exit
fi
 

DIRHOME=/scripts/clima/users/renato/figsIniciaisBAM1.2
SCRIPTS=${DIRHOME}/scripts
DATAOUT=${DIRHOME}/dataout
DATAIN=${DIRHOME}/datain


yyyyci=${1} # ${yyyyci}
mmci=${2}   # ${mmci}


yyyytri1=$(date -u +"%Y" -d "${yyyyci}${mmci}15 2 months")  # ${yyyytri1}
mmtri1=$(date -u +"%m" -d "${yyyyci}${mmci}15 2 months")    # ${mmtri1}
mmmtri1=$(date -u +"%b" -d "${yyyyci}${mmci}15 2 months")   # ${mmmtri1}
mmmtri2=$(date -u +"%b" -d "${yyyyci}${mmci}15 3 months")   # ${mmmtri2}
yyyytri3=$(date -u +"%Y" -d "${yyyyci}${mmci}15 4 months")  # ${yyyytri3}
mmtri3=$(date -u +"%m" -d "${yyyyci}${mmci}15 4 months")    # ${mmtri3}
mmmtri3=$(date -u +"%b" -d "${yyyyci}${mmci}15 4 months")   # ${mmmtri3}
temp=$(date -u +"%Y%m01" -d "${yyyyci}${mmci}15 5 months")  # ${temp}
lddtri3=$(date -u +"%d" -d "${temp} 1 day ago")             # ${lddtri3}
yyyytri1lagyyyytri3=$(echo "${yyyytri3}-${yyyytri1}" | bc)  # ${yyyytri1lagyyyytri3}
TRI=$(echo "${mmmtri1}" | cut -c1)$(echo "${mmmtri2}" | cut -c1)$(echo "${mmmtri3}" | cut -c1)  # ${TRI}




rm -f ${SCRIPTS}/prev_anom.gs
cat <<EOGS>${SCRIPTS}/prev_anom.gs
'reinit'


* (1) previsao: 
say 'open ../dataout/previsao.ctl'
'open ../dataout/previsao.ctl'


* (2) hindcast:
say 'open ../dataout/hindcast.ctl'
'open ../dataout/hindcast.ctl'


* (3) coorelacao deste modelo:
say 'open ../dataout/correlacao.ctl'
'open ../dataout/correlacao.ctl'



'set dfile 2'

'define climo=ave(prec.2, t=1, t=30)'
'define prevanom=prec.1(t=1)-climo'
'define climot=ave(tmp.2, t=1, t=30)'
'define prevanomt=tmp.1(t=1)-climot'
'define climop=ave(SPMT.2, t=1, t=30)'
'define prevanomp=(SPMT.1(t=1)+1000)-(climop+1000)'


'set x 1 384'
'set y 1 191'


* Escrevendo binario campo de prev de anomalia deste modelo:
'set gxout fwrite'
say 'set fwrite ../dataout/previsao_anomalia_prec_global.bin'
'set fwrite ../dataout/previsao_anomalia_prec_global.bin'
'd prec.1(t=1)'
'd prevanom'
'disable fwrite'

* Escrevendo figura desta previsao sem mascara estatistica:
'set gxout shaded'
'set display color white'
'run rgbset2.gs'
* branco:
'set rgb 240 255 255 255'
'set grid off'
'set mproj scaled'
'c'
'set annot 0 0'
'set xlab off'
'set ylab off'
'set grads off'

'set clevs    -400  -300  -200  -100  -50  -25   25  50  100  200  300  400'
'set ccols  78    77    76    75    74   73   240  32  33   34   35   36   37'
 
'd smth9(prevanom)'
'cbarn 0.9 0 5.5 0.35'

'set strsiz 0.21 0.22'
'set string 1 c 6'
'draw string 5.5 8.25  Previsao de Anomalia de Precipitacao ${TRI}/${yyyytri1}' 
'draw string 5.5 7.90   CPTEC - BAM v1.2'


'gxprint ../dataout/previsao_anomalia_prec_global.png'

'c'


* Escrevendo figura da correlacao deste modelo:
'set gxout shaded'
'set display color white'
'run rgbset.gs'
* branco:
'set rgb 240 255 255 255'
'set grid off'
'set mproj scaled'
'c'
'set annot 0 0'
'set xlab off'
'set ylab off'
'set grads off'

'color.gs -levs  -0.8 -0.6 -0.4 -0.3 -0.2 0.2 0.3 0.4 0.6 0.8 -kind chocolate->gold->white->sienna->maroon'

'd smth9(corr.3(t=1))'
'cbarn 0.9 0 5.5 0.35'

'set strsiz 0.21 0.22'
'set string 1 c 6'
'draw string 5.5 8.25  Correlacao de Anomalia de Precipitacao ${TRI}' 
'draw string 5.5 7.90   CPTEC - BAM v1.2'

'set strsiz 0.11 0.12'
'set string 1 c 6'
'draw string 5.5 0.65  Fonte observada: CPCP' 

'gxprint ../dataout/correlacao_anomalia_prec_global.png'

'c'


* TEMPERATURA:--------------------------------------------


* Escrevendo binario campo de prev de anomalia deste modelo:
'set gxout fwrite'
say 'set fwrite ../dataout/previsao_anomalia_tmp_global.bin'
'set fwrite ../dataout/previsao_anomalia_tmp_global.bin'
'd tmp.1(t=1)'
'd prevanomt'
'disable fwrite'


* Escrevendo figura desta previsao sem mascara estatistica:
'set gxout shaded'
'set display color white'
'run rgbset.gs'
* branco:
'set rgb 240 255 255 255'
'set grid off'
'set mproj scaled'
'c'
'set annot 0 0'
'set xlab off'
'set ylab off'
'set grads off'

'set clevs -4 -3 -2 -1 -0.5 0.5 1 2 3 4'
'set ccols 49 48 46 44 42 240 22 24 26 28 29'


'd smth9(prevanomt)'
'cbarn 0.9 0 5.5 0.35'

'set strsiz 0.21 0.22'
'set string 1 c 6'
'draw string 5.5 8.25  Previsao de Anomalia de Temperatura a 2m ${TRI}/${yyyytri1}' 
'draw string 5.5 7.90   CPTEC - BAM v1.2'

'gxprint ../dataout/previsao_anomalia_tmp_global.png'

'c'


* Escrevendo figura da correlacao deste modelo:
'set gxout shaded'
'set display color white'
'run rgbset.gs'
* branco:
'set rgb 240 255 255 255'
'set grid off'
'set mproj scaled'
'c'
'set annot 0 0'
'set xlab off'
'set ylab off'
'set grads off'

'color.gs -levs  -0.8 -0.6 -0.4 -0.3 -0.2 0.2 0.3 0.4 0.6 0.8 -kind chocolate->gold->white->sienna->maroon'
'd smth9(corrt.3(t=1))'
'cbarn 0.9 0 5.5 0.35'

'set strsiz 0.21 0.22'
'set string 1 c 6'
'draw string 5.5 8.25  Correlacao de Anomalia de Temperatura a 2m ${TRI}' 
'draw string 5.5 7.90   CPTEC - BAM v1.2'

'set strsiz 0.11 0.12'
'set string 1 c 6'
'draw string 5.5 0.65  Fonte observada: ERA5' 


'gxprint ../dataout/correlacao_anomalia_tmp_global.png'
'c'


* PRESSAO:--------------------------------------------

* Escrevendo binario campo de prev de anomalia deste modelo:
'set gxout fwrite'
say 'set fwrite ../dataout/previsao_anomalia_spmt_global.bin'
'set fwrite ../dataout/previsao_anomalia_spmt_global.bin'
'd spmt.1(t=1)'
'd prevanomp'
'disable fwrite'


* Escrevendo figura desta previsao sem mascara estatistica:
'set gxout shaded'
'set display color white'
'run rgbset2.gs'
* branco:
'set rgb 240 255 255 255'
'set grid off'
'set mproj scaled'
'c'
'set annot 0 0'
'set xlab off'
'set ylab off'
'set grads off'



*'color.gs -levs  -6000 -5000 -4000 -3000 -2000 -1000 1000 2000 3000 4000 5000 6000 -kind blue->white->red'
'color.gs -levs  -6 -5 -4 -3 -2 -1 1 2 3 4 5 6 -kind blue->white->red'
 
'd smth9(prevanomp)'
'cbarn 0.9 0 5.5 0.35'


'set strsiz 0.21 0.22'
'set string 1 c 6'
'draw string 5.5 8.25  Previsao de Anomalia de Pressao ao Nivel do mar ' 
'draw string 5.5 7.90   [spmt] ${TRI}/${yyyytri1} - CPTEC - BAM v1.2'

'gxprint ../dataout/previsao_anomalia_spmt_global.png'

'c'


* Escrevendo figura da correlacao deste modelo:
'set gxout shaded'
'set display color white'
'run rgbset.gs'
* branco:
'set rgb 240 255 255 255'
'set grid off'
'set mproj scaled'
'c'
'set annot 0 0'
'set xlab off'
'set ylab off'
'set grads off'

'color.gs -levs  -0.8 -0.6 -0.4 -0.3 -0.2 0.2 0.3 0.4 0.6 0.8 -kind chocolate->gold->white->sienna->maroon'
'd smth9(corrp.3(t=1))'
'cbarn 0.9 0 5.5 0.35'

'set strsiz 0.21 0.22'
'set string 1 c 6'
'draw string 5.5 8.25  Correlacao de Anomalia de Pressao ${TRI}' 
'draw string 5.5 7.90   CPTEC - BAM v1.2'

'set strsiz 0.11 0.12'
'set string 1 c 6'
'draw string 5.5 0.65  Fonte observada: ERA5' 


'gxprint ../dataout/correlacao_anomalia_spmt_global.png'
'c'

'quit'
EOGS

#grads -lc "run prev_anom.gs" -g 800x600
grads -blc "run prev_anom.gs"

montage -tile 1x2 -geometry +1+1 -background white \
../dataout/previsao_anomalia_prec_global.png \
../dataout/correlacao_anomalia_prec_global.png \
../dataout/prev_corr_prec_global.png

montage -tile 1x2 -geometry +1+1 -background white \
../dataout/previsao_anomalia_tmp_global.png \
../dataout/correlacao_anomalia_tmp_global.png \
../dataout/prev_corr_tmp_global.png

montage -tile 1x2 -geometry +1+1 -background white \
../dataout/previsao_anomalia_spmt_global.png \
../dataout/correlacao_anomalia_spmt_global.png \
../dataout/prev_corr_spmt_global.png

display ../dataout/prev_corr_prec_global.png ../dataout/prev_corr_tmp_global.png ../dataout/prev_corr_spmt_global.png 
