#!/bin/ksh

if [ $# -ne 2 ]
then
   echo ""
   echo "${0} YYYY MM"
   echo ""
   exit
fi
 

DIRHOME=/scripts/clima/users/renato/figsIniciaisBAM1.2
SCRIPTS=${DIRHOME}/scripts
DATAOUT=${DIRHOME}/dataout
DATAIN=${DIRHOME}/datain


yyyyci=${1} # ${yyyyci}
mmci=${2}   # ${mmci}


yyyytri1=$(date -u +"%Y" -d "${yyyyci}${mmci}15 2 months")  # ${yyyytri1}
mmtri1=$(date -u +"%m" -d "${yyyyci}${mmci}15 2 months")    # ${mmtri1}
mmmtri1=$(date -u +"%b" -d "${yyyyci}${mmci}15 2 months")   # ${mmmtri1}
mmmtri2=$(date -u +"%b" -d "${yyyyci}${mmci}15 3 months")   # ${mmmtri2}
yyyytri3=$(date -u +"%Y" -d "${yyyyci}${mmci}15 4 months")  # ${yyyytri3}
mmtri3=$(date -u +"%m" -d "${yyyyci}${mmci}15 4 months")    # ${mmtri3}
mmmtri3=$(date -u +"%b" -d "${yyyyci}${mmci}15 4 months")   # ${mmmtri3}
temp=$(date -u +"%Y%m01" -d "${yyyyci}${mmci}15 5 months")  # ${temp}
lddtri3=$(date -u +"%d" -d "${temp} 1 day ago")             # ${lddtri3}
yyyytri1lagyyyytri3=$(echo "${yyyytri3}-${yyyytri1}" | bc)  # ${yyyytri1lagyyyytri3}
TRI=$(echo "${mmmtri1}" | cut -c1)$(echo "${mmmtri2}" | cut -c1)$(echo "${mmmtri3}" | cut -c1)  # ${TRI}




rm -f ${SCRIPTS}/previsao.gs
cat <<EOGS>${SCRIPTS}/previsao.gs
'reinit'

ddi=09
i=1
while (ddi <= 23)
   say 'open /oper/share/clima/modelos/BAM1.2/${TRI}/${yyyyci}${mmci}'ddi'/gposmm${yyyyci}${mmci}'ddi'.ctl'
   'open /oper/share/clima/modelos/BAM1.2/${TRI}/${yyyyci}${mmci}'ddi'/gposmm${yyyyci}${mmci}'ddi'.ctl'
   
   say 'define varprec'i'=sum(prec.'i', time=01${mmmtri1}${yyyytri1}, time=${lddtri3}${mmmtri3}${yyyytri3})'
   'define varprec'i'=sum(prec.'i', time=01${mmmtri1}${yyyytri1}, time=${lddtri3}${mmmtri3}${yyyytri3})'
   
   say 'define varTP2M'i'=ave(TP2M.'i', time=01${mmmtri1}${yyyytri1}, time=${lddtri3}${mmmtri3}${yyyytri3})'
   'define varTP2M'i'=ave(TP2M.'i', time=01${mmmtri1}${yyyytri1}, time=${lddtri3}${mmmtri3}${yyyytri3})'

   say 'define varSPMT'i'=ave(SPMT.'i', time=01${mmmtri1}${yyyytri1}, time=${lddtri3}${mmmtri3}${yyyytri3})'
   'define varSPMT'i'=ave(SPMT.'i', time=01${mmmtri1}${yyyytri1}, time=${lddtri3}${mmmtri3}${yyyytri3})'

   ddi=ddi+1
   i=i+1
endwhile
say ''



'define ens=prec.2(t=1)*0.0'
'define enst=TP2M.2(t=1)*0.0'
'define ensp=SPMT.2(t=1)*0.0'


i=1
while (i <= 15)

   say 'define ens=ens+varprec'i''
   'define ens=ens+varprec'i''
   
   say 'define enst=enst+varTP2M'i''
   'define enst=enst+varTP2M'i''
   
   say 'define ensp=ensp+varSPMT'i''
   'define ensp=ensp+varSPMT'i''

   i=i+1
endwhile
'define ens=ens/'15
'define enst=enst/'15
'define ensp=ensp/'15


'set x 1 384'
'set y 1 192'

'set gxout fwrite'
'set fwrite ../dataout/previsao.bin'


'd ens'
'd enst'
'd ensp'

'disable fwrite'


'quit'




EOGS

rm -f ${DATAOUT}/previsao.bin
grads -blc "run previsao.gs"

rm -f ${DATAOUT}/previsao.ctl
cat <<EOCTL>${DATAOUT}/previsao.ctl
DSET ^previsao.bin
UNDEF -9.99e+08
TITLE AMJ
xdef   384 linear    0.000   0.9375000000
ydef   192 linear  -89.531   0.9375000000
ZDEF     6  LEVELS  1000  925  850  500  250  200
TDEF     1 LINEAR ${mmmtri1}${yyyyci} 1mo
VARS    3
PREC    0 99 TOTAL PRECIPITATION                     (Kg M**-2 Day**-1)
TMP    0 99 TEMPERATURE AT 2-M FROM SURFACE         (K               )
SPMT    0 99 TIME MEAN SEA LEVEL PRESSURE            (Mb-1000         )
ENDVARS
EOCTL
